<?php

############################################################################################
# fanKounter PHP script                                                          counter.php
# fanatiko(lubcecco@hotmail.com),Italy                                                  v4.0

############################################################################################
# INFORMAZIONI SUL FILE
############################################################################################
# Modulo motore del fanKounter per la rilevazione dei reports statistici.
#
# Fai riferimento alla seguente documentazione distribuita con questo software per:
#  license.txt - le condizioni di utilizzo, modifica e redistribuzione per l'utente finale;
#   readme.txt - la guida completa all'installazione e all'uso, con consigli preziosi;
# whatsnew.txt - i bugs trovati e corretti e le novit rispetto alle versioni precedenti.

############################################################################################
# PARAMETRI IN INPUT
############################################################################################

import_request_variables("gpc","par__");

$par__id=(isset($par__id)&&($par__id!==""))?$par__id:FALSE;
$par__mode=(isset($par__mode)&&((strtolower($par__mode)==="hidden")||(strtolower($par__mode)==="test")))?strtolower($par__mode):"graphic";
$par__referrer=(isset($par__referrer)&&($par__referrer!==""))?$par__referrer:FALSE;
$par__timestamp=(isset($par__timestamp)&&($par__timestamp!==""))?round($par__timestamp/1000,0):FALSE;
$par__cookie=(isset($par__cookie))?$par__cookie:FALSE;

error_reporting(($par__mode==="test")?E_ALL:0);

############################################################################################
# INCLUSIONE MODULI ESTERNI
############################################################################################

require("config.inc.php");
require("url.inc.php");

unset($inf__engine,$dic__keys_minlen,$dic__keys_exclude);

############################################################################################
# LETTURA CONFIGURAZIONE DA FILE
############################################################################################

if(($par__id!==FALSE)&&file_exists(implode("",$glo__config_f))){
 include(implode("",$glo__config_f));
}
elseif(($par__id!==FALSE)){
 require("magic.inc.php");
}
else
 $par__id=FALSE;

############################################################################################
# DEFINIZIONE VARIABILI DI SUPPORTO
############################################################################################

settype($cnf__htime_sync_server,"integer");
$aux__now=time()+$cnf__htime_sync_server*3600;

settype($cnf__start_count,"integer");
$aux__counting=($cnf__start_count<0)?0:$cnf__start_count;

$aux__codes_debug=array("reports"=>array(),"graphic"=>array(),"hidden"=>array());

$aux__remote_addr=(array_key_exists("REMOTE_ADDR",$_SERVER))?$_SERVER["REMOTE_ADDR"]:"";
$aux__user_agent=(array_key_exists("HTTP_USER_AGENT",$_SERVER))?addslashes(preg_replace("/[\x01-\x1F]/","",$_SERVER["HTTP_USER_AGENT"])):"";
$aux__location=new URL(((array_key_exists("HTTP_REFERER",$_SERVER))?$_SERVER["HTTP_REFERER"]:""));
$aux__referrer=new URL($par__referrer);

$aux__img=array("id"=>"","type"=>"");

############################################################################################
# GESTIONE REPORT ACCESSI
############################################################################################

function _report_manager_($__safe_mode=TRUE){
 global $glo__counter_f,$glo__reports_f,$glo__archive_f,$glo__field_sep,$glo__EOL;
 global $aux__now,$aux__counting,$aux__codes_debug,$aux__remote_addr,$aux__user_agent,$aux__location,$aux__referrer;

 function _CRC_($__string){
  for($__count=0,$__CRC=0;$__count<strlen($__string);$__count++)
   $__CRC+=ord($__string{$__count})*(1+$__count);

  return $__CRC;
 }

 if(file_exists(implode("",$glo__counter_f))){
  if(($__counter_fid=fopen(implode("",$glo__counter_f),(($__safe_mode)?"rb":"r+b")))!==FALSE){
   if(($__counting=fgets($__counter_fid,4096))!==FALSE){
    settype($__counting,"integer");
    $aux__counting=1+$__counting;

    if(!$__safe_mode){
     if(($__reports_fid=fopen(implode("",$glo__reports_f),"ab"))!==FALSE){
      if(fseek($__counter_fid,0,SEEK_SET)!==-1){
       if(fwrite($__counter_fid,$aux__counting)===strlen($aux__counting)){
        $__report=$aux__counting.$glo__field_sep.$aux__now.$glo__field_sep.$aux__remote_addr.$glo__field_sep.$aux__user_agent.$glo__field_sep.$aux__location->_safe_().$glo__field_sep.$aux__referrer->_safe_();

        set_magic_quotes_runtime(0);

        if(fwrite($__reports_fid,$__report.$glo__field_sep._CRC_($__report).$glo__EOL,4096)===-1)
         array_push($aux__codes_debug["reports"],"<span style='color:red;'>(16)</span>");

        ini_restore("magic_quotes_runtime");
       }
       else
        array_push($aux__codes_debug["reports"],"<span style='color:red;'>(15)</span>");
      }
      else
       array_push($aux__codes_debug["reports"],"<span style='color:red;'>(14)</span>");

      fclose($__reports_fid);
     }
     else
      array_push($aux__codes_debug["reports"],"<span style='color:red;'>(13)</span>");
    }
   }
   else
    array_push($aux__codes_debug["reports"],"<span style='color:red;'>(12)</span>");

   fclose($__counter_fid);
  }
  else
   array_push($aux__codes_debug["reports"],"<span style='color:red;'>(11)</span>");
 }
 elseif((!file_exists(implode("",$glo__reports_f)))&&(!file_exists(implode("",$glo__archive_f)))){
  if(($__counter_fid=fopen(implode("",$glo__counter_f),"wb"))!==FALSE){
   if(fwrite($__counter_fid,$aux__counting)===-1)
    array_push($aux__codes_debug["reports"],"<span style='color:red;'>(10)</span>");
   fclose($__counter_fid);
  }
  else
   array_push($aux__codes_debug["reports"],"<span style='color:red;'>(09)</span>");
 }
 else
  array_push($aux__codes_debug["reports"],"<span style='color:red;'>(08)</span>");

 $aux__counting=(($aux__counting>99999999)?"overflow":$aux__counting);
 return;
}

function _set_cookie_(){
 global $cnf__mtime_unique_accs,$cnf__expire_on_midnight,$cnf__count_per_pages;
 global $par__id,$par__timestamp;
 global $aux__now,$aux__location;

 $__cookie_id=$par__id;
 $__cookie_id.=($cnf__count_per_pages)?"":("~".urldecode($aux__location->_normalize_()));

 settype($cnf__mtime_unique_accs,"integer");
 $__expire=$aux__now+60*(($cnf__mtime_unique_accs>0)?$cnf__mtime_unique_accs:-1);

 if($cnf__expire_on_midnight){
  $__midnight=mktime(0,0,0,date("n",$aux__now),1+date("j",$aux__now),date("Y",$aux__now));
  $__expire=min($__expire,$__midnight);
 }

 $__expire-=(($par__timestamp!==FALSE)&&(abs($aux__now-$par__timestamp)<24*60*60))?$aux__now-$par__timestamp:0;

 setcookie("cookie[".$__cookie_id."]",date("D j M Y, g:i a",$aux__now),$__expire);
 return;
}

function _get_cookie_(){
 global $cnf__count_per_pages;
 global $par__id,$par__cookie;
 global $aux__location;

 if($par__cookie!==FALSE){
  $__cookie_id=$par__id;
  $__cookie_id.=($cnf__count_per_pages)?"":("~".urldecode($aux__location->_normalize_()));
  return ((array_key_exists($__cookie_id,$par__cookie))?TRUE:FALSE);
 }

 return FALSE;
}

function _unique_check_(){
 global $glo__access_f,$glo__field_sep,$glo__EOL;
 global $cnf__mtime_unique_accs,$cnf__expire_on_midnight,$cnf__count_per_pages;
 global $par__timestamp;
 global $aux__now,$aux__remote_addr,$aux__user_agent,$aux__location;

 $__times=array();
 $__infos=array();
 $__accesses=(file_exists(implode("",$glo__access_f)))?file(implode("",$glo__access_f)):array();

 foreach($__accesses as $__access){
  list($__expire,$__info)=explode($glo__field_sep,$__access,2);

  if($aux__now<$__expire){
   array_push($__times,$__expire);
   array_push($__infos,$__info);
  }
 }

 $__info=(($cnf__count_per_pages)?"":($aux__location->_normalize_().$glo__field_sep)).$aux__remote_addr.$glo__field_sep.$aux__user_agent.$glo__EOL;

 if(!in_array($__info,$__infos)){
  settype($cnf__mtime_unique_accs,"integer");
  $__expire=$aux__now+60*(($cnf__mtime_unique_accs>0)?$cnf__mtime_unique_accs:-1);

  if($cnf__expire_on_midnight){
   $__midnight=mktime(0,0,0,date("n",$aux__now),1+date("j",$aux__now),date("Y",$aux__now));
   $__expire=min($__expire,$__midnight);
  }

  $__expire-=(($par__timestamp!==FALSE)&&(abs($aux__now-$par__timestamp)<24*60*60))?$aux__now-$par__timestamp:0;

  array_push($__times,$__expire);
  array_push($__infos,$__info);

  set_magic_quotes_runtime(0);

  if(($__access_fid=fopen(implode("",$glo__access_f),"wb"))!==FALSE){
   for($__count=0;$__count<count($__times);$__count++)
    fwrite($__access_fid,$__times[$__count].$glo__field_sep.$__infos[$__count]);

   fclose($__access_fid);
  }

  ini_restore("magic_quotes_runtime");
  return TRUE;
 }

 return FALSE;
}

function _licit_ip_(){
 global $cnf__IPs_ignore_list;
 global $aux__remote_addr;

 foreach($cnf__IPs_ignore_list as $__ip){
  $__ip=preg_replace("/\./","\\.",$__ip);
  $__ip=preg_replace("/\?/","\\d",$__ip);
  $__ip=preg_replace("/\*/","\\d{1,3}",$__ip);

  if(preg_match("/^".$__ip."$/",$aux__remote_addr))
   return FALSE;
 }

 return TRUE;
}

function _licit_domain_(){
 global $cnf__licit_domains_list;
 global $aux__location;

 $__norm_location=$aux__location->_normalize_();

 if(count($cnf__licit_domains_list)>0)
  foreach($cnf__licit_domains_list as $__path){
   $__domain=new URL($__path);
   $__norm_url=$__domain->_normalize_();

   if(($__norm_url!=="?")&&preg_match("/^".preg_quote($__norm_url,"/")."/",$__norm_location))
    return TRUE;
  }
 else
  return TRUE;

 return FALSE;
}

if($par__id!==FALSE){
 $__safe_mode=TRUE;

 if(($__log_fid=fopen(implode("",$glo__log_f),"ab"))!==FALSE){
  if(($glo__lock_files)?flock($__log_fid,LOCK_EX):TRUE){
   if(!_get_cookie_()){
    if(_licit_ip_()){
     if(_licit_domain_()){
      if(($cnf__access_support)?_unique_check_():TRUE){
       $__safe_mode=FALSE;
       _set_cookie_();
      }
      else
       array_push($aux__codes_debug["reports"],"<span style='color:blue;'>(07)</span>");
     }
     else
      array_push($aux__codes_debug["reports"],"<span style='color:blue;'>(06)</span>");
    }
    else
     array_push($aux__codes_debug["reports"],"<span style='color:blue;'>(05)</span>");
   }
   else
    array_push($aux__codes_debug["reports"],"<span style='color:blue;'>(04)</span>");

   _report_manager_($__safe_mode);

   if($glo__lock_files)
    flock($__log_fid,LOCK_UN);
  }
  else
   array_push($aux__codes_debug["reports"],"<span style='color:red;'>(03)</span>");

  fclose($__log_fid);
 }
 else
  array_push($aux__codes_debug["reports"],"<span style='color:red;'>(02)</span>");

 unset($__safe_mode,$__log_fid);
}
else
 array_push($aux__codes_debug["reports"],"<span style='color:blue;'>(01)</span>");

############################################################################################
# DEFINIZIONE FUNZIONI PER IMMAGINI
############################################################################################

function _img_from_base_(){
 global $cnf__img_base;
 global $aux__codes_debug,$aux__img;

 $aux__img["id"]="";
 $aux__img["type"]="";

 if(($cnf__img_base==="")||(!file_exists($cnf__img_base)))
  array_push($aux__codes_debug["graphic"],"<span style='color:blue;'>(17)</span>");
 elseif($aux__img["id"]=imagecreatefrompng($cnf__img_base)){
  $aux__img["type"]="png";
  array_push($aux__codes_debug["graphic"],"<span style='color:green;'>(18)</span>");
 }
 elseif($aux__img["id"]=imagecreatefromjpeg($cnf__img_base)){
  $aux__img["type"]="jpeg";
  array_push($aux__codes_debug["graphic"],"<span style='color:green;'>(19)</span>");
 }
 elseif($aux__img["id"]=imagecreatefromwbmp($cnf__img_base)){
  $aux__img["type"]="wbmp";
  array_push($aux__codes_debug["graphic"],"<span style='color:green;'>(20)</span>");
 }
 elseif($aux__img["id"]=imagecreatefromgif($cnf__img_base)){
  $aux__img["type"]="gif";
  array_push($aux__codes_debug["graphic"],"<span style='color:green;'>(21)</span>");
 }
 else
  array_push($aux__codes_debug["graphic"],"<span style='color:red;'>(22)</span>");

 return ((($aux__img["id"]!=="")&&($aux__img["type"]!==""))?TRUE:FALSE);
}

function _img_from_blank_($__w,$__h,$__mode){
 global $cnf__box_draw;
 global $aux__codes_debug,$aux__img;

 $cnf__box_draw=TRUE;

 $aux__img["id"]="";
 $aux__img["type"]="";

 if(imagetypes()&IMG_PNG){
  $aux__img["id"]=imagecreate($__w,$__h);
  $aux__img["type"]="png";
  array_push($aux__codes_debug[$__mode],"<span style='color:green;'>(23)</span>");
 }
 elseif(imagetypes()&IMG_JPEG){
  $aux__img["id"]=imagecreate($__w,$__h);
  $aux__img["type"]="jpeg";
  array_push($aux__codes_debug[$__mode],"<span style='color:green;'>(24)</span>");
 }
 elseif(imagetypes()&IMG_WBMP){
  $aux__img["id"]=imagecreate($__w,$__h);
  $aux__img["type"]="wbmp";
  array_push($aux__codes_debug[$__mode],"<span style='color:green;'>(25)</span>");
 }
 elseif(imagetypes()&IMG_GIF){
  $aux__img["id"]=imagecreate($__w,$__h);
  $aux__img["type"]="gif";
  array_push($aux__codes_debug[$__mode],"<span style='color:green;'>(26)</span>");
 }
 else
  array_push($aux__codes_debug[$__mode],"<span style='color:red;'>(27)</span>");

 return ((($aux__img["id"]!=="")&&($aux__img["type"]!==""))?TRUE:FALSE);
}

function _draw_image_($__mode){
 global $aux__codes_debug,$aux__img;

 switch($aux__img["type"]){
  case "png":
   header("Cache-Control: no-store, no-cache");
   header("Content-type: image/png");
   if(!imagepng($aux__img["id"]))
    array_push($aux__codes_debug[$__mode],"<span style='color:red;'>(28)</span>");
   break;
  case "jpeg":
   header("Cache-Control: no-store, no-cache");
   header("Content-type: image/jpeg");
   if(!imagejpeg($aux__img["id"],"",100))
    array_push($aux__codes_debug[$__mode],"<span style='color:red;'>(29)</span>");
   break;
  case "wbmp":
   header("Cache-Control: no-store, no-cache");
   header("Content-type: image/bmp");
   if(!imagewbmp($aux__img["id"]))
    array_push($aux__codes_debug[$__mode],"<span style='color:red;'>(30)</span>");
   break;
  case "gif":
   header("Cache-Control: no-store, no-cache");
   header("Content-type: image/gif");
   if(!imagegif($aux__img["id"]))
    array_push($aux__codes_debug[$__mode],"<span style='color:red;'>(31)</span>");
   break;
 }

 return;
}

############################################################################################
# MODALITA' GRAPHIC
############################################################################################

if(($par__mode==="graphic")||($par__mode==="test"))
 do{
  if($cnf__text_size===1)
   $__box_size=array("W"=>42,"H"=>8);
  elseif($cnf__text_size===2)
   $__box_size=array("W"=>49,"H"=>14);
  elseif($cnf__text_size===4)
   $__box_size=array("W"=>66,"H"=>16);
  elseif($cnf__text_size===5)
   $__box_size=array("W"=>73,"H"=>16);
  else{
   $cnf__text_size=3;
   $__box_size=array("W"=>57,"H"=>14);
  }

  if(!_img_from_base_())
   if(!_img_from_blank_($__box_size["W"],$__box_size["H"],"graphic"))
    break;

  if(strtolower($cnf__box_align["H"])==="left")
   $__box_base["X"]=0;
  elseif((strtolower($cnf__box_align["H"])==="center")||(strtolower($cnf__box_align["H"])==="middle"))
   $__box_base["X"]=floor((imagesx($aux__img["id"])-$__box_size["W"])/2);
  elseif(strtolower($cnf__box_align["H"])==="right")
   $__box_base["X"]=imagesx($aux__img["id"])-$__box_size["W"];
  else
   $__box_base["X"]=(int)$cnf__box_align["H"];
  $__box_base["X"]=($__box_base["X"]<0)?0:$__box_base["X"];

  if(strtolower($cnf__box_align["V"])==="top")
   $__box_base["Y"]=0;
  elseif((strtolower($cnf__box_align["V"])==="center")||(strtolower($cnf__box_align["V"])==="middle"))
   $__box_base["Y"]=floor((imagesy($aux__img["id"])-$__box_size["H"])/2);
  elseif(strtolower($cnf__box_align["V"])==="bottom")
   $__box_base["Y"]=imagesy($aux__img["id"])-$__box_size["H"];
  else
   $__box_base["Y"]=(int)$cnf__box_align["V"];
  $__box_base["Y"]=($__box_base["Y"]<0)?0:$__box_base["Y"];

  $__bgcolor=imagecolorallocate($aux__img["id"],$cnf__box_color["R"],$cnf__box_color["G"],$cnf__box_color["B"]);
  if($cnf__box_draw)
   imagefilledrectangle($aux__img["id"],$__box_base["X"],$__box_base["Y"],$__box_base["X"]+$__box_size["W"]-1,$__box_base["Y"]+$__box_size["H"]-1,$__bgcolor);

  $cnf__pad_char=trim($cnf__pad_char);
  $cnf__pad_char=($cnf__pad_char==="")?" ":$cnf__pad_char{0};

  $__txtcolor=imagecolorallocate($aux__img["id"],$cnf__text_color["R"],$cnf__text_color["G"],$cnf__text_color["B"]);
  imagestring($aux__img["id"],$cnf__text_size,$__box_base["X"]+1,$__box_base["Y"],str_pad($aux__counting,8,$cnf__pad_char,STR_PAD_LEFT),$__txtcolor);

  if($par__mode==="graphic")
   _draw_image_("graphic");

  imagedestroy($aux__img["id"]);

  unset($__box_size,$__box_base,$__bgcolor,$__txtcolor);
 }while(FALSE);

############################################################################################
# MODALITA' HIDDEN
############################################################################################

if(($par__mode==="hidden")||($par__mode==="test"))
 if(_img_from_blank_(1,1,"hidden")){
  if($par__mode==="hidden")
   _draw_image_("hidden");
  imagedestroy($aux__img["id"]);
 }

############################################################################################
# MODALITA' TEST
############################################################################################

if($par__mode==="test"){
 echo"<!DOCTYPE html PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN'>";
 echo"\n\n";
 echo"<!-- fanKounter PHP Script by fanatiko //-->"."\n";
 echo"<!-- ".$glo__script_hp." //-->"."\n";
 echo"<!-- mailto:".$glo__script_email." //-->";
 echo"\n\n";
 echo"<html>";
 echo"<head>";
 echo"<meta http-equiv='content-type' content='text/html; charset=iso-8859-1' />";
 echo"<title>fanKounter :: test for ".(($par__id!==FALSE)?$par__id:"?")."</title>";
 echo"<style type='text/css'>pre{margin:10px;font-family:Fixedsys;font-size:9pt;color:#000040;}</style>";

 if(TRUE){
  echo"<script type='text/javascript' language='javascript' src='".$glo__script_hp."/adnews.js'></script>";
  echo"<script type='text/javascript' language='javascript'>wr_news('".$glo__script_vs[0]."')</script>";
 }

 echo"</head>";
 echo"<body>";
 echo"<pre>                    :</pre>";
 echo"<pre><span style='text-decoration:underline;'>     Script Version</span> : ".$glo__script_vs[0].".".$glo__script_vs[1]."</pre>";
 echo"<pre>                    :</pre>";
 echo"<pre><span style='text-decoration:underline;'>         Counter ID</span> : ".(($par__id!==FALSE)?$par__id:"?")."</pre>";
 echo"<pre><span style='text-decoration:underline;'>       Count Number</span> : ".$aux__counting."</pre>";
 echo"<pre>                    :</pre>";
 echo"<pre><span style='text-decoration:underline;'>       Report Codes</span> : ".implode(" ",$aux__codes_debug["reports"])."</pre>";
 echo"<pre><span style='text-decoration:underline;'>      Graphic Codes</span> : ".implode(" ",$aux__codes_debug["graphic"])."</pre>";
 echo"<pre><span style='text-decoration:underline;'>       Hidden Codes</span> : ".implode(" ",$aux__codes_debug["hidden"])."</pre>";
 echo"<pre>                    :</pre>";
 echo"</body>";
 echo"</html>";
 echo"\n\n";
}

############################################################################################
# EPILOGO ESECUZIONE
############################################################################################

unset($glo__licit_domains_list,$glo__config_f,$glo__counter_f,$glo__reports_f,$glo__archive_f,$glo__access_f,$glo__log_f,$glo__tmp_f,$glo__bck_f,$glo__field_sep,$glo__EOL,$glo__lock_files,$glo__auto_backup,$glo__get_host_name,$glo__script_vs,$glo__script_hp,$glo__script_email);
unset($cnf__start_count,$cnf__img_base,$cnf__pad_char,$cnf__text_size,$cnf__text_color,$cnf__box_draw,$cnf__box_color,$cnf__box_align,$cnf__licit_domains_list,$cnf__IPs_ignore_list,$cnf__mtime_unique_accs,$cnf__expire_on_midnight,$cnf__count_per_pages,$cnf__access_support,$cnf__htime_sync_server,$cnf__style_sheet,$cnf__last_entries,$cnf__last_months,$cnf__last_dates,$cnf__limit_view,$cnf__ksize_limit_db);
unset($par__id,$par__mode,$par__referrer,$par__timestamp,$par__cookie);
unset($aux__now,$aux__counting,$aux__codes_debug,$aux__remote_addr,$aux__user_agent,$aux__location,$aux__referrer,$aux__img);

############################################################################################

?>