<?php

############################################################################################
# fanKounter PHP script                                                        stats.inc.php
# fanatiko(lubcecco@hotmail.com),Italy                                                  v4.0

############################################################################################
# INFORMAZIONI SUL FILE
############################################################################################
# Modulo auto-incluso per l'elaborazione dei reports e l'archiviazione dei dati.
#
# Fai riferimento alla seguente documentazione distribuita con questo software per:
#  license.txt - le condizioni di utilizzo, modifica e redistribuzione per l'utente finale;
#   readme.txt - la guida completa all'installazione e all'uso, con consigli preziosi;
# whatsnew.txt - i bugs trovati e corretti e le novit rispetto alle versioni precedenti.

############################################################################################
# BLOCCA L'ESECUZIONE STANDALONE
############################################################################################

if(array_key_exists("SCRIPT_NAME",$_SERVER))
 if(preg_replace("/^.*\/([^\/]+)$/","\\1",$_SERVER["SCRIPT_NAME"])==="stats.inc.php")
  exit("Can't start standalone.");

############################################################################################
# INCLUSIONE MODULI ESTERNI
############################################################################################

require("url.inc.php");
require("inf-country.inc.php");
require("inf-browser.inc.php");
require("inf-os.inc.php");

############################################################################################
# DEFINIZIONE DELLA CLASSE CALENDAR
############################################################################################

class Calendar{
 var $__year;

 function Calendar(){
  $this->__year=array();
  return;
 }

 function _make_year_($__year){
  settype($__year,"string");

  if(!array_key_exists($__year,$this->__year)){
   $this->__year[$__year]=array();

   for($__month=0;$__month<12;$__month++)
    if(checkdate(1+$__month,31,$__year))
     $this->__year[$__year][$__month]=array_fill(0,31,0);
    elseif(checkdate(1+$__month,30,$__year))
     $this->__year[$__year][$__month]=array_fill(0,30,0);
    elseif(checkdate(1+$__month,29,$__year))
     $this->__year[$__year][$__month]=array_fill(0,29,0);
    else
     $this->__year[$__year][$__month]=array_fill(0,28,0);

   ksort($this->__year,SORT_NUMERIC);
  }

  return;
 }

 function _set_hit_($__timestamp){
  $__year=date("Y",$__timestamp);
  $__month=date("n",$__timestamp);
  $__date=date("j",$__timestamp);

  settype($__month,"integer");
  settype($__date,"integer");

  if(checkdate($__month,$__date,$__year)){
   $this->_make_year_($__year);
   $this->__year[$__year][$__month-1][$__date-1]++;
   return TRUE;
  }

  return FALSE;
 }

 function _get_hits_($__timestamp,$__type){
  $__year=date("Y",$__timestamp);
  $__month=date("n",$__timestamp);
  $__date=date("j",$__timestamp);

  settype($__month,"integer");
  settype($__date,"integer");

  if(array_key_exists($__year,$this->__year))
   switch(strtolower($__type{0})){
    case "d":
     if(array_key_exists($__month-1,$this->__year[$__year]))
      if(array_key_exists($__date-1,$this->__year[$__year][$__month-1]))
       return $this->__year[$__year][$__month-1][$__date-1];
     break;
    case "m":
     if(array_key_exists($__month-1,$this->__year[$__year]))
      return array_sum($this->__year[$__year][$__month-1]);
     break;
    case "y":
     return array_sum(array_map("array_sum",$this->__year[$__year]));
   }

  return 0;
 }

 function _get_years_(){
  $__years=array();

  foreach($this->__year as $__year_k=>$__month_a)
   $__years[$__year_k]=array_sum(array_map("array_sum",$__month_a));

  return $__years;
 }

 function _max_hits_in_date_(){
  global $aux__now;

  $__max=array("timestamp"=>$aux__now,"hits"=>0);

  foreach($this->__year as $__year_k=>$__month_a)
   foreach($__month_a as $__month_k=>$__date_a)
    foreach($__date_a as $__date_k=>$__hits)
     if($__hits>=$__max["hits"]){
      $__max["timestamp"]=mktime(12,00,00,1+$__month_k,1+$__date_k,$__year_k);
      $__max["hits"]=$__hits;
     }

  return $__max;
 }

 function _max_hits_in_month_(){
  global $aux__now;

  $__max=array("timestamp"=>$aux__now,"hits"=>0);

  foreach($this->__year as $__year_k=>$__month_a)
   foreach($__month_a as $__month_k=>$__date_a)
    if(($__hits=array_sum($__date_a))>=$__max["hits"]){
     $__max["timestamp"]=mktime(12,00,00,1+$__month_k,1,$__year_k);
     $__max["hits"]=$__hits;
    }

  return $__max;
 }

 function _update_($__celendar){
  $this->__year=$__celendar;
  return;
 }

 function _safe_($__var_name){
  global $glo__EOL;

  $__safe="";

  foreach($this->__year as $__year=>$__month){
   $__safe.="\$".$__var_name."[\"".$__year."\"]=array(";

   for($__m=0,$__fm=TRUE;$__m<count($__month);$__m++){
    $__safe.=(($__fm)?"":",")."array(";

    for($__d=0,$__fd=TRUE;$__d<count($__month[$__m]);$__d++){
     $__safe.=(($__fd)?"":",").$__month[$__m][$__d];
     $__fd=FALSE;
    }

    $__fm=FALSE;
    $__safe.=")";
   }

   $__safe.=");".$glo__EOL;
  }

  return $__safe;
 }
}

############################################################################################
# DEFINIZIONE VARIABILI DI SUPPORTO
############################################################################################

$dat__counting=0;
$dat__archs=0;

$aux__calendar=new Calendar();

$dat__day=array_fill(0,7,0);
$dat__time=array_fill(0,24,0);
$dat__country=array();
$dat__browser=array();
$dat__os=array();
$dat__location=array();
$dat__referrer=array();
$dat__engine=array();
$dat__enkey=array();

$dat__entry=array();

############################################################################################
# ACCESSO ESCLUSIVO AI FILES DEI DATI
############################################################################################

if(($__log_fid=fopen(implode("",$glo__log_f),"ab"))===FALSE)
 exit("Critical Error (opening '"._filename_($glo__log_f)."' file).");
elseif((($glo__lock_files)?(!flock($__log_fid,LOCK_EX)):FALSE))
 exit("Critical Error (locking '"._filename_($glo__log_f)."' file).");

############################################################################################
# ALLINEAMENTO DATI STATISTICI DA ARCHIVIO
############################################################################################

if(file_exists(implode("",$glo__archive_f))){
 $dat__calendar=array();

 include(implode("",$glo__archive_f));

 $aux__calendar->_update_($dat__calendar);
 unset($dat__calendar);

 $__delete_to=count($dat__entry)-$cnf__last_entries;
 for($__count=1;$__count<$__delete_to;$__count++)
  unset($dat__entry[$__count]);
 unset($__count,$__delete_to);

 reset($dat__entry);
 $dat__entry=array_values($dat__entry);
}

############################################################################################
# DEFINIZIONE DELLA CLASSE REPORT
############################################################################################

class Report{
 var $__day;
 var $__time;
 var $__ip;
 var $__host;
 var $__country2l;
 var $__country;
 var $__browser;
 var $__os;
 var $__location;
 var $__referrer;
 var $__engine;
 var $__enkeys;

 function _system_info_($__elem,$__data){
  foreach($__data as $__regexp=>$__name)
   if(preg_match($__regexp,$__elem))
    return preg_replace($__regexp,$__name,$__elem);

  return "?";
 }

 function Report($__tim,$__add,$__age,$__loc,$__ref){
  global $glo__get_host_name;
  global $inf__country,$inf__browser,$inf__os;

  $this->__day=(6+date("w",$__tim))%7;
  $this->__time=(int)date("G",$__tim);
  $this->__ip=(preg_match("/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/",$__add))?$__add:"?";

  if($glo__get_host_name){
   $this->__host=($this->__ip!=="?")?gethostbyaddr($this->__ip):"?";
   $this->__host=($this->__host!==$this->__ip)?$this->__host:"?";
  }
  else
   $this->__host="?";

  $this->__country2l="?";
  if(preg_match("/\.(\w{2})$/",$this->__host,$__result))
   if(array_key_exists(strtolower($__result[1]),$inf__country))
    $this->__country2l=strtoupper($__result[1]);

  $this->__country=($this->__country2l!=="?")?$inf__country[strtolower($this->__country2l)]:"?";
  $this->__browser=Report::_system_info_($__age,$inf__browser);
  $this->__os=Report::_system_info_($__age,$inf__os);

  $__url=new URL($__loc,TRUE);
  $this->__location=$__url->_normalize_();

  $__url=new Referrer($__ref,TRUE);
  if($__url->_is_engine_()){
   $this->__referrer=FALSE;
   $this->__engine=$__url->_get_engine_name_();
   $this->__enkeys=$__url->_get_engine_keys_();
  }
  else{
   $this->__referrer=$__url->_normalize_();
   $this->__engine=FALSE;
   $this->__enkeys=FALSE;
  }

  return;
 }
}

############################################################################################
# LETTURA ED ELABORAZIONE DEI NUOVI REPORTS
############################################################################################

function _revCRC_($__string,$__CRC){
 for($__count=0;$__count<strlen($__string);$__count++)
  $__CRC-=ord($__string{$__count})*(1+$__count);

 return (($__CRC===0)?TRUE:FALSE);
}

function _set_dat_($__elem,&$__data,$__create_flag=TRUE){
 if(array_key_exists($__elem,$__data))
  ++$__data[$__elem];
 elseif($__create_flag)
  $__data[$__elem]=1;

 return;
}

set_magic_quotes_runtime(0);

if(file_exists(implode("",$glo__reports_f))){
 if(($__reports_fid=fopen(implode("",$glo__reports_f),"rb"))!==FALSE){
  while(!feof($__reports_fid)){
   if(($__buffer=fgets($__reports_fid,4096))!==FALSE){
    list($__ent,$__tim,$__add,$__age,$__loc,$__ref,$__crc)=explode($glo__field_sep,substr($__buffer,0,-1),7);

    if(_revCRC_($__ent.$glo__field_sep.$__tim.$glo__field_sep.$__add.$glo__field_sep.$__age.$glo__field_sep.$__loc.$glo__field_sep.$__ref,$__crc)&&($__ent>$dat__counting))
     if($aux__calendar->_set_hit_($__tim)){
      $dat__counting=$__ent;

      $__report=new Report($__tim,$__add,stripslashes($__age),$__loc,$__ref);

      _set_dat_($__report->__day,$dat__day,FALSE);
      _set_dat_($__report->__time,$dat__time,FALSE);
      _set_dat_($__report->__country,$dat__country);
      _set_dat_($__report->__browser,$dat__browser);
      _set_dat_($__report->__os,$dat__os);
      _set_dat_($__report->__location,$dat__location);

      if($__report->__referrer!==FALSE)
       _set_dat_($__report->__referrer,$dat__referrer);

      if($__report->__engine!==FALSE){
       _set_dat_($__report->__engine,$dat__engine);

       foreach($__report->__enkeys as $__enkey)
        _set_dat_($__enkey,$dat__enkey);

       unset($__enkey);
      }

      $__entry=array();
      $__entry["entry"]=$__ent;
      $__entry["timestamp"]=$__tim;
      $__entry["ip"]=$__report->__ip;
      $__entry["host"]=$__report->__host;
      $__entry["country2l"]=$__report->__country2l;
      $__entry["country"]=$__report->__country;
      $__entry["browser"]=$__report->__browser;
      $__entry["os"]=$__report->__os;
      $__entry["location"]=$__report->__location;
      $__entry["referrer"]=($__report->__referrer!==FALSE)?$__report->__referrer:"";
      $__entry["engine"]=($__report->__engine!==FALSE)?$__report->__engine:"";
      $__entry["enkeys"]=($__report->__enkeys!==FALSE)?implode(" ",$__report->__enkeys):"";

      array_push($dat__entry,$__entry);
      unset($__entry,$__report);

      if((count($dat__entry)-1)>$cnf__last_entries){
       unset($dat__entry[1]);

       reset($dat__entry);
       $dat__entry=array_values($dat__entry);
      }
     }

    unset($__ent,$__tim,$__add,$__age,$__loc,$__ref,$__crc);
   }

   unset($__buffer);
  }

  fclose($__reports_fid);
 }
 else
  exit("Critical Error (opening '"._filename_($glo__reports_f)."' file).");

 unset($__reports_fid);
}

ini_restore("magic_quotes_runtime");

############################################################################################
# RIORDINO DEI DATI
############################################################################################

reset($dat__country);
reset($dat__browser);
reset($dat__os);
reset($dat__location);
reset($dat__referrer);
reset($dat__engine);
reset($dat__enkey);

arsort($dat__country,SORT_NUMERIC);
arsort($dat__browser,SORT_NUMERIC);
arsort($dat__os,SORT_NUMERIC);
arsort($dat__location,SORT_NUMERIC);
arsort($dat__referrer,SORT_NUMERIC);
arsort($dat__engine,SORT_NUMERIC);
arsort($dat__enkey,SORT_NUMERIC);

############################################################################################
# ARCHIVIAZIONE DATI STATISTICI
############################################################################################

function _databackup_(){
 global $glo__counter_f,$glo__reports_f,$glo__archive_f,$glo__bck_f;
 global $aux__now;

 require("zip.lib.php");
 $__zip=new zipfile();

 $__zip->addFile("This backup was created by fanKounter on ".date("d.m.Y, H:i",$aux__now).".","readme.txt",$aux__now);

 if(file_exists(implode("",$glo__counter_f)))
  $__zip->addFile(file_get_contents(implode("",$glo__counter_f)),_filename_($glo__counter_f),$aux__now);

 if(file_exists(implode("",$glo__reports_f)))
  $__zip->addFile(file_get_contents(implode("",$glo__reports_f)),_filename_($glo__reports_f),$aux__now);

 if(file_exists(implode("",$glo__archive_f)))
  $__zip->addFile(file_get_contents(implode("",$glo__archive_f)),_filename_($glo__archive_f),$aux__now);
 else
  $__zip->addFile("<?php /* empty */ ?>",_filename_($glo__archive_f),$aux__now);

 if(($__bck_fid=fopen(implode("",$glo__bck_f),"wb"))!==FALSE){
  fwrite($__bck_fid,$__zip->file());
  fclose($__bck_fid);
 }

 return;
}

function _datastore_($__data_arr,$__var_name,$__val_numeric=TRUE,$__safe_key=TRUE){
 global $glo__EOL;

 $__the_first=TRUE;
 $__buffer="\$".$__var_name."=array(";

 foreach($__data_arr as $__key=>$__val){
  $__buffer.=(($__the_first)?"":",").(($__safe_key)?("\"".$__key."\"=>"):"").(($__val_numeric)?$__val:("\"".$__val."\""));
  $__the_first=FALSE;
 }

 $__buffer.=");".$glo__EOL;
 return $__buffer;
}

set_magic_quotes_runtime(0);

if(_filesize_($glo__reports_f)>(1024*$cnf__ksize_limit_db)){
 $__buffer_log="[STORE TASK NUMBER #".(++$dat__archs)."]".$glo__EOL;
 $__buffer_log.="Time              : ".date("d.m.Y, H:i",$aux__now).$glo__EOL;
 $__buffer_log.="Hits on Counter   : ".$dat__counting.$glo__EOL;
 $__buffer_log.="Report-File Size  : "._filesize_($glo__reports_f,"k")."kB".$glo__EOL;
 $__buffer_log.="Limit for RF Size : ".$cnf__ksize_limit_db."kB".$glo__EOL;
 $__buffer_log.="File Backup       : ".(($glo__auto_backup)?_filename_($glo__bck_f):"none").$glo__EOL;
 $__buffer_log.="Task Result       : %s".$glo__EOL.$glo__EOL;

 $__buffer_data="<?php".$glo__EOL.$glo__EOL;
 $__buffer_data.="# The archive file for '".$par__id."' counter.".$glo__EOL;
 $__buffer_data.="# This file was created by fanKounter on ".date("d.m.Y, H:i",$aux__now).".".$glo__EOL.$glo__EOL;
 $__buffer_data.="\$dat__counting=".$dat__counting.";".$glo__EOL;
 $__buffer_data.="\$dat__archs=".$dat__archs.";".$glo__EOL;
 $__buffer_data.=($aux__calendar->_safe_("dat__calendar"));
 $__buffer_data.=_datastore_($dat__day,"dat__day",TRUE,FALSE);
 $__buffer_data.=_datastore_($dat__time,"dat__time",TRUE,FALSE);
 $__buffer_data.=_datastore_($dat__country,"dat__country");
 $__buffer_data.=_datastore_($dat__browser,"dat__browser");
 $__buffer_data.=_datastore_($dat__os,"dat__os");
 $__buffer_data.=_datastore_($dat__location,"dat__location");
 $__buffer_data.=_datastore_($dat__referrer,"dat__referrer");
 $__buffer_data.=_datastore_($dat__engine,"dat__engine");
 $__buffer_data.=_datastore_($dat__enkey,"dat__enkey");

 for($__count=0;$__count<count($dat__entry);$__count++)
  $__buffer_data.=_datastore_($dat__entry[$__count],"dat__entry[".$__count."]",FALSE);

 $__buffer_data.=$glo__EOL."?>";

 if(($__tmp_fid=fopen(implode("",$glo__tmp_f),"wb"))===FALSE){
  $__buffer_log=sprintf($__buffer_log,("FAILURE (System Error creating '"._filename_($glo__tmp_f)."' file)"));
  --$dat__archs;
 }
 elseif(fwrite($__tmp_fid,$__buffer_data)!==strlen($__buffer_data)){
  fclose($__tmp_fid);
  unlink(implode("",$glo__tmp_f));

  $__buffer_log=sprintf($__buffer_log,("FAILURE (System Error writing in '"._filename_($glo__tmp_f)."' file)"));
  --$dat__archs;
 }
 else{
  fclose($__tmp_fid);

  if($glo__auto_backup)
   _databackup_();

  if(copy(implode("",$glo__tmp_f),implode("",$glo__archive_f)))
   $__buffer_log=sprintf($__buffer_log,((unlink(implode("",$glo__reports_f)))?"SUCCESSFUL":("HALF SUCCESS (Can't delete '"._filename_($glo__reports_f)."' file)")));
  else{
   $__buffer_log=sprintf($__buffer_log,("FAILURE (System Error copying '"._filename_($glo__tmp_f)."' to '"._filename_($glo__archive_f)."' file)"));
   --$dat__archs;
  }

  unlink(implode("",$glo__tmp_f));
 }

 fwrite($__log_fid,$__buffer_log);
 unset($__tmp_fid,$__buffer_data,$__buffer_log);
}

ini_restore("magic_quotes_runtime");

############################################################################################
# RILASCIO DELLE RISORSE ACQUISITE
############################################################################################

if($glo__lock_files)
 flock($__log_fid,LOCK_UN);

fclose($__log_fid);
unset($__log_fid);

############################################################################################
# EPILOGO ESECUZIONE
############################################################################################

unset($dic__keys_minlen,$dic__keys_exclude);
unset($inf__engine,$inf__country,$inf__browser,$inf__os);

############################################################################################

?>