<?php

############################################################################################
# fanKounter PHP script                                                            stats.php
# fanatiko(lubcecco@hotmail.com),Italy                                                  v4.0

############################################################################################
# INFORMAZIONI SUL FILE
############################################################################################
# Modulo per la stampa delle statistiche.
#
# Fai riferimento alla seguente documentazione distribuita con questo software per:
#  license.txt - le condizioni di utilizzo, modifica e redistribuzione per l'utente finale;
#   readme.txt - la guida completa all'installazione e all'uso, con consigli preziosi;
# whatsnew.txt - i bugs trovati e corretti e le novit rispetto alle versioni precedenti.

############################################################################################
# PARAMETRI IN INPUT
############################################################################################

error_reporting(0);

import_request_variables("gpc","par__");

$par__id=(isset($par__id)&&($par__id!==""))?$par__id:FALSE;

############################################################################################
# INCLUSIONE MODULI ESTERNI
############################################################################################

require("config.inc.php");
require("lang.inc.php");

############################################################################################
# LETTURA CONFIGURAZIONE DA FILE
############################################################################################

if(($par__id!==FALSE)&&file_exists(implode("",$glo__config_f))){
 include(implode("",$glo__config_f));
}
else
 exit("Input Error (no valid id given).");

settype($cnf__mtime_unique_accs,"integer");
settype($cnf__htime_sync_server,"integer");
settype($cnf__last_entries,"integer");
settype($cnf__last_months,"integer");
settype($cnf__last_dates,"integer");
settype($cnf__limit_view,"integer");
settype($cnf__ksize_limit_db,"integer");

$cnf__mtime_unique_accs=($cnf__mtime_unique_accs>0)?$cnf__mtime_unique_accs:0;
$cnf__last_entries=($cnf__last_entries>0)?$cnf__last_entries:0;
$cnf__last_months=($cnf__last_months>0)?$cnf__last_months:0;
$cnf__last_dates=($cnf__last_dates>0)?$cnf__last_dates:0;
$cnf__limit_view=($cnf__limit_view>0)?$cnf__limit_view:0;
$cnf__ksize_limit_db=($cnf__ksize_limit_db>0)?$cnf__ksize_limit_db:0;

############################################################################################
# DEFINIZIONE VARIABILI DI SUPPORTO
############################################################################################

list($aux__usec_s,$aux__sec_s)=explode(" ",microtime());

$aux__now=time()+$cnf__htime_sync_server*3600;

$aux__max_d=array();
$aux__max_m=array();

############################################################################################
# ELABORAZIONE DATI
############################################################################################

require("stats.inc.php");

$aux__max_d=$aux__calendar->_max_hits_in_date_();
$aux__max_m=$aux__calendar->_max_hits_in_month_();

############################################################################################
# DEFINIZIONE FUNZIONI DI SUPPORTO
############################################################################################

function _filename_($__pieces){
 $__pieces["path"]="";
 return implode("",$__pieces);
}

function _filesize_($__pieces,$__unit="b"){
 if(file_exists(implode("",$__pieces)))
  switch(strtolower($__unit{0})){
   case "k":
    return round(filesize(implode("",$__pieces))/1024,1);
   default:
    return filesize(implode("",$__pieces));
  }

 return 0;
}

function _timestamp_($__past,$__type="d"){
 global $aux__now;

 switch(strtolower($__type{0})){
  case "y":
   return mktime(12,0,0,1,1,date("Y",$aux__now)-$__past);
  case "m":
   return mktime(12,0,0,date("n",$aux__now)-$__past,1,date("Y",$aux__now));
  default:
   return mktime(12,0,0,date("n",$aux__now),date("j",$aux__now)-$__past,date("Y",$aux__now));
 }
}

function _date_($__timestamp,$__type="d"){
 global $lan__months,$lan__days;

 switch(strtolower($__type{0})){
  case "w":
   return $lan__days[(6+date("w",$__timestamp))%7];
  case "m":
   $__month=$lan__months[date("n",$__timestamp)-1];
   return ($__month." ".date("Y",$__timestamp));
  default:
   $__month=$lan__months[date("n",$__timestamp)-1];
   return (date("j",$__timestamp)." ".$__month." ".date("Y",$__timestamp));
 }
}

function _past_($__timestamp,$__prec=0){
 global $aux__now;

 $__last=round(($aux__now-$__timestamp)/(24*60*60),$__prec);
 return (($__last<1)?1:$__last);
}

function _time_($__hour){
 return (str_pad($__hour,2,"0",STR_PAD_LEFT).":00 ".chr(247)." ".str_pad(1+$__hour,2,"0",STR_PAD_LEFT)).":00";
}

function _counters_(){
 global $glo__config_f;

 $__counters=array();
 $__dir_name=($glo__config_f["path"]==="")?".":$glo__config_f["path"];
 $__config_f=$glo__config_f;
 $__config_f["path"]="";
 $__config_f["prefix"]=preg_quote($__config_f["prefix"],"/");
 $__config_f["id"]="(.+)";
 $__config_f["postfix"]=preg_quote($__config_f["postfix"],"/");
 $__config_f["ext"]=preg_quote($__config_f["ext"],"/");
 $__config_name=implode("",$__config_f);

 if(($__dir=@opendir($__dir_name))!==FALSE){
  while(($__file=readdir($__dir))!==FALSE)
   if(preg_match("/^".$__config_name."$/",$__file,$__result))
    array_push($__counters,$__result[1]);

  closedir($__dir);
 }

 reset($__counters);
 sort($__counters,SORT_STRING);
 return $__counters;
}

function _cut_($__string,$__len){
 if(strlen($__string)>$__len)
  return (substr($__string,0,$__len-3)."...");

 return $__string;
}

function _restrict_($__data){
 global $cnf__limit_view;
 global $lan__strings;

 $__data_r=array_slice($__data,0,$cnf__limit_view);
 $__data_r[$lan__strings["other"]]=array_sum(array_slice($__data,$cnf__limit_view));

 if($__data_r[$lan__strings["other"]]===0)
  unset($__data_r[$lan__strings["other"]]);

 return $__data_r;
}

function _format_($__string,$__par1=FALSE,$__par2=FALSE,$__par3=FALSE,$__par4=FALSE){
 static $__tags=array(
  "/\[hiT\]/i",
  "/\[\/hiT\]/i",
  "/\[dateT\]/i",
  "/\[\/dateT\]/i",
  "/\[hi\]/i",
  "/\[\/hi\]/i",
  "/\[date\]/i",
  "/\[\/date\]/i",
  "/\[count\]/i",
  "/\[\/count\]/i"
 );

 static $__reps=array(
  "<span class='titleHi'>",
  "</span>",
  "<span title='%4\$s' class='titleHi' style='cursor:help;'>",
  "</span>",
  "<span class='summaryHi'>",
  "</span>",
  "<span title='%4\$s' class='summaryHi' style='cursor:help;'>",
  "</span>",
  "<span class='summaryCount'>",
  "</span>"
 );

 return (sprintf(preg_replace($__tags,$__reps,htmlspecialchars($__string,ENT_QUOTES)),$__par1,$__par2,$__par3,$__par4));
}

function _percentage_($__data,$__prec=1){
 $__data_p=array();

 $__data_p["~max~"]=(count($__data)>0)?max($__data):0;
 $__data_p["~sum~"]=array_sum($__data);

 foreach($__data as $key=>$val)
  $__data_p[$key]=($__data_p["~sum~"]<1)?0:round(100*$val/$__data_p["~sum~"],$__prec);

 return $__data_p;
}

function _bar_($__val,$__max,$__width){
 $__bar="<table cellspacing='0' cellpadding='0'>";
 $__bar.="<tr>";
 $__bar.="<td class='bar' style='width:".(($__max<1)?0:round(($__width-50)*$__val/$__max,0))."px;'>";
 $__bar.="</td>";
 $__bar.="<td>";
 $__bar.="<p class='bar'>".$__val."</p>";
 $__bar.="</td>";
 $__bar.="</tr>";
 $__bar.="</table>";

 return $__bar;
}

function _notes_(){
 global $cnf__mtime_unique_accs,$cnf__expire_on_midnight,$cnf__count_per_pages;
 global $lan__strings;

 if($cnf__mtime_unique_accs===0)
  $__notes=_format_($lan__strings["notes01a"]);
 else{
  $__time=array("h"=>0,"m"=>$cnf__mtime_unique_accs);

  while($__time["m"]>=60){
   ++$__time["h"];
   $__time["m"]-=60;
  }

  $__notes=_format_($lan__strings["notes01b"],$__time["h"],$__time["m"]);

  if($cnf__expire_on_midnight)
   $__notes.="<br />"._format_($lan__strings["notes02"]);

  if($cnf__count_per_pages)
   $__notes.="<br />"._format_($lan__strings["notes03a"]);
  else
   $__notes.="<br />"._format_($lan__strings["notes03b"]);
 }

 return $__notes;
}

############################################################################################
# OUTPUT
############################################################################################

if($dat__counting===0)
 exit("Counter *".$par__id."* not initialized.");

echo"<!DOCTYPE html PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN'>";
echo"\n\n";
echo"<!-- fanKounter PHP Script by fanatiko //-->"."\n";
echo"<!-- ".$glo__script_hp." //-->"."\n";
echo"<!-- mailto:".$glo__script_email." //-->";
echo"\n\n";
echo"<html>";
echo"<head>";
echo"<meta http-equiv='content-type' content='text/html; charset=iso-8859-1' />";
echo"<title>"._format_($lan__strings["title"],$par__id)."</title>";
echo"<link type='text/css' rel='stylesheet' href='".$cnf__style_sheet."' />";

if(TRUE){
 echo"<script type='text/javascript' language='javascript' src='".$glo__script_hp."/adnews.js'></script>";
 echo"<script type='text/javascript' language='javascript'>wr_news('".$glo__script_vs[0]."')</script>";
}

echo"</head>";
echo"<body>";
echo"<div align='center'>";
echo"<table class='page'>";
echo"<tr>";
echo"<td>";
echo"<table class='section'>";
echo"<tr>";
echo"<td>";
echo"<p class='title'>"._format_($lan__strings["prologue"],$par__id,_date_($aux__now,"d"),date("G:i",$aux__now),_date_($aux__now,"w"))."</p>";
echo"<p class='credits'>2002 fanKounter - PHP Script by fanatiko - mailto: <a href='mailto:".$glo__script_email."' title='".$glo__script_email."' class='credits'>".$glo__script_email."</a> - <a href='".$glo__script_hp."' target='_top' title='".$glo__script_hp."' class='credits'>".$glo__script_hp."</a></p>";
echo"</td>";
echo"</tr>";
echo"</table>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<form id='jksel' name='jksel' method='post' action='".$_SERVER["SCRIPT_NAME"]."' target='_top'>";
echo"<select name='id' size='1' onchange='javascript:self.document.jksel.submit()' class='selector'>";
echo"<option value='' selected='selected'>"._format_($lan__strings["selector"])."</option>";

foreach(($__counters=_counters_()) as $__counter)
 echo"<option value='".$__counter."'>".chr(187)." ".$__counter."</option>";
unset($__counter,$__counters);

echo"</select>";
echo"</form>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>". _format_($lan__strings["field01"])."</p>";
echo"</th>";
echo"<th class='field1'>";
echo"<p>". _format_($lan__strings["field02"])."</p>";
echo"</th>";
echo"</tr>";
echo"<tr>";
echo"<td rowspan='2' class='summary'>";
echo"<p class='summary'>"._format_($lan__strings["summary01"],$aux__calendar->_get_hits_($aux__now,"d"))."<br />"._format_($lan__strings["summary02"],$aux__calendar->_get_hits_(_timestamp_(1,"d"),"d"))."</p>";
echo"<p class='summary'>"._format_($lan__strings["summary03"],$aux__calendar->_get_hits_($aux__now,"m"))."<br />"._format_($lan__strings["summary04"],$aux__calendar->_get_hits_(_timestamp_(1,"m"),"m"))."</p>";
echo"<p class='summary'>"._format_($lan__strings["summary05"],$aux__calendar->_get_hits_($aux__now,"y"))."<br />"._format_($lan__strings["summary06"],$aux__calendar->_get_hits_(_timestamp_(1,"y"),"y"))."</p>";
echo"</td>";
echo"<td class='summary'>";
echo"<p class='summary'>"._format_($lan__strings["info01"],_filename_($glo__config_f))."<br />"._format_($lan__strings["info02"],_filename_($glo__reports_f),_filesize_($glo__reports_f,"k"),$cnf__ksize_limit_db)."<br />"._format_($lan__strings["info03"],_filename_($glo__archive_f),_filesize_($glo__archive_f,"k"),$dat__archs)."</p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td class='summary'>";
echo"<p class='summary'>"._format_($lan__strings["info04"],_date_($dat__entry[0]["timestamp"],"d"),$dat__entry[0]["entry"]-1,FALSE,_date_($dat__entry[0]["timestamp"],"w"))."<br />"._format_($lan__strings["info05"],$dat__counting,_past_($dat__entry[0]["timestamp"],0))."<br />"._format_($lan__strings["info06"],1+$dat__counting-$dat__entry[0]["entry"])."</p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<th colspan='2' class='field1'>";
echo"<p>". _format_($lan__strings["field03"])."</p>";
echo"</th>";
echo"</tr>";
echo"<tr>";
echo"<td colspan='2' class='summary'>";
echo"<p class='summary'>"._format_($lan__strings["curio01"],round((1+$dat__counting-$dat__entry[0]["entry"])/_past_($dat__entry[0]["timestamp"],3),1))."<br />"._format_($lan__strings["curio02"],$aux__max_d["hits"],_date_($aux__max_d["timestamp"],"d"),FALSE,_date_($aux__max_d["timestamp"],"w"))."<br />"._format_($lan__strings["curio03"],$aux__max_m["hits"],_date_($aux__max_m["timestamp"],"m"))."</p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<th colspan='2' class='field1'>";
echo"<p>". _format_($lan__strings["field04"])."</p>";
echo"</th>";
echo"</tr>";
echo"<tr>";
echo"<td colspan='2' class='summary'>";
echo"<p class='summary'>"._notes_()."</p>";
echo"</td>";
echo"</tr>";
echo"</table>";
echo"</td>";
echo"</tr>";

unset($dat__counting,$dat__archs);

echo"<tr>";
echo"<td>";
echo"<p><a href='javascript:self.scroll(0,0)' class='top'>"._format_($lan__strings["top"])."</a></p>";
echo"</td>";
echo"</tr>";

if($cnf__last_entries>0){
 echo"<tr>";
 echo"<td>";
 echo"<p class='title'>"._format_($lan__strings["section01"],$cnf__last_entries)."</p>";
 echo"</td>";
 echo"</tr>";
 echo"<tr>";
 echo"<td>";
 echo"<table class='section'>";
 echo"<tr>";
 echo"<th class='field1'>";
 echo"<p>"._format_($lan__strings["field05"])."</p>";
 echo"</th>";
 echo"<th class='field1'>";
 echo"<p>"._format_($lan__strings["field06"])."</p>";
 echo"</th>";
 echo"<th class='field1'>";
 echo"<p>"._format_($lan__strings["field07"])."</p>";
 echo"</th>";
 echo"<th class='field1'>";
 echo"<p>"._format_($lan__strings["field08"])."</p>";
 echo"</th>";
 echo"<th class='field1'>";
 echo"<p>"._format_($lan__strings["field09"])."</p>";
 echo"</th>";
 echo"<th class='field1'>";
 echo"<p>"._format_($lan__strings["field10"])."</p>";
 echo"</th>";
 echo"<th class='field1'>";
 echo"<p>"._format_($lan__strings["field11"])."</p>";
 echo"</th>";
 echo"</tr>";

 for($__count=(count($dat__entry)<=$cnf__last_entries)?0:1;$__count<count($dat__entry);$__count++){
  echo"<tr>";
  echo"<th class='field2'>";
  echo"<p>".$dat__entry[$__count]["entry"]."</p>";
  echo"</th>";
  echo"<td class='data1'>";
  echo"<p title='"._date_($dat__entry[$__count]["timestamp"],"w")."' style='cursor:help;'>"._date_($dat__entry[$__count]["timestamp"],"d")."</p>";
  echo"</td>";
  echo"<td class='data1'>";
  echo"<p>".date("G:i",$dat__entry[$__count]["timestamp"])."</p>";
  echo"</td>";
  echo"<td class='data2'>";

  if($dat__entry[$__count]["ip"]!=="?")
   echo"<p title='".(($dat__entry[$__count]["host"]!=="?")?$dat__entry[$__count]["host"]:_format_($lan__strings["unknownhost"]))."' style='cursor:help;'>".$dat__entry[$__count]["ip"]."</p>";
  else
   echo"<p style='font-style:italic;'>"._format_($lan__strings["unknownip"])."</p>";

  echo"</td>";
  echo"<td class='data2'>";

  if($dat__entry[$__count]["country2l"]!=="?")
   echo"<p title='".$dat__entry[$__count]["country"]."' style='cursor:help;'>".$dat__entry[$__count]["country2l"]."</p>";
  else
   echo"<p style='font-style:italic;'>"._format_($lan__strings["unknowncountry"])."</p>";

  echo"</td>";
  echo"<td class='data3'>";

  if($dat__entry[$__count]["browser"]!=="?")
   echo"<p>".$dat__entry[$__count]["browser"]."</p>";
  else
   echo"<p style='font-style:italic;'>"._format_($lan__strings["unknownbrowser"])."</p>";

  echo"</td>";
  echo"<td class='data3'>";

  if($dat__entry[$__count]["os"]!=="?")
   echo"<p>".$dat__entry[$__count]["os"]."</p>";
  else
   echo"<p style='font-style:italic;'>"._format_($lan__strings["unknownos"])."</p>";

  echo"</td>";
  echo"</tr>";
  echo"<tr>";
  echo"<th class='field3'>";
  echo"<p>"._format_($lan__strings["field12"])."</p>";
  echo"</th>";
  echo"<td colspan='6' class='data4'>";

  if($dat__entry[$__count]["location"]!=="?"){
   $__location=URL::_print_($dat__entry[$__count]["location"]);
   echo"<p><a href='".$__location."' title='".$__location."' class='data4'>"._cut_($__location,80)."</a></p>";
   unset($__location);
  }
  else
   echo"<p style='font-style:italic;'>"._format_($lan__strings["nulllocation"])."</p>";

  echo"</td>";
  echo"</tr>";
  echo"<tr>";
  echo"<th class='field3'>";
  echo"<p>"._format_($lan__strings["field13"])."</p>";
  echo"</th>";
  echo"<td colspan='6' class='data4'>";

  if($dat__entry[$__count]["engine"]!=="")
   echo"<p><a href='http://www.".$dat__entry[$__count]["engine"]."' title='http://www.".$dat__entry[$__count]["engine"]."' class='data4'>"._cut_($dat__entry[$__count]["engine"],30)."</a> ("._cut_($dat__entry[$__count]["enkeys"],50).")</p>";
  elseif($dat__entry[$__count]["referrer"]!=="?"){
   $__referrer=Referrer::_print_($dat__entry[$__count]["referrer"]);
   echo"<p><a href='".$__referrer."' title='".$__referrer."' class='data4'>"._cut_($__referrer,80)."</a></p>";
   unset($__referrer);
  }
  else
   echo"<p style='font-style:italic;'>"._format_($lan__strings["nullreferrer"])."</p>";

  echo"</td>";
  echo"</tr>";
 }
 unset($__count);

 echo"</table>";
 echo"</td>";
 echo"</tr>";
 echo"<tr>";
 echo"<td>";
 echo"<p><a href='javascript:self.scroll(0,0)' class='top'>"._format_($lan__strings["top"])."</a></p>";
 echo"</td>";
 echo"</tr>";
}

unset($dat__entry);

echo"<tr>";
echo"<td>";
echo"<p class='title'>"._format_($lan__strings["section02"])."</p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field14"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:200px'>";
echo"<p>"._format_($lan__strings["field15"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field16"])."</p>";
echo"</th>";
echo"</tr>";

$dat__location=_restrict_($dat__location);
$__perc=_percentage_($dat__location);

foreach($dat__location as $__page=>$__hits){
 echo"<tr>";
 echo"<td class='data1' style='text-align:left;'>";

 if($__page==="?")
  echo"<p style='font-style:italic;'>".$lan__strings["nulllocation"]."</p>";
 elseif($__page===$lan__strings["other"])
  echo"<p style='font-style:italic;'>".$__page."</p>";
 else{
  $__location=URL::_print_($__page);
  echo"<p><a href='".$__location."' target='_top' title='".$__location."' class='data1'>"._cut_($__location,60)."</a></p>";
  unset($__location);
 }

 echo"</td>";
 echo"<td class='graphic'>";
 echo _bar_($__hits,$__perc["~max~"],200);
 echo"</td>";
 echo"<td class='data3'>";
 echo"<p>".$__perc[$__page]."</p>";
 echo"</td>";
 echo"</tr>";
}

unset($__perc,$__page,$__hits);

echo"</table>";
echo"</td>";
echo"</tr>";

unset($dat__location);

echo"<tr>";
echo"<td>";
echo"<p><a href='javascript:self.scroll(0,0)' class='top'>"._format_($lan__strings["top"])."</a></p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<p class='title'>"._format_($lan__strings["section03"])."</p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field17"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:200px'>";
echo"<p>"._format_($lan__strings["field18"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field19"])."</p>";
echo"</th>";
echo"</tr>";

if(count($dat__referrer)>0){
 $dat__referrer=_restrict_($dat__referrer);
 $__perc=_percentage_($dat__referrer);

 foreach($dat__referrer as $__url=>$__hits){
  echo"<tr>";
  echo"<td class='data1' style='text-align:left;'>";

  if($__url==="?")
   echo"<p style='font-style:italic;'>".$lan__strings["nullreferrer"]."</p>";
  elseif($__url===$lan__strings["other"])
   echo"<p style='font-style:italic;'>".$__url."</p>";
  else{
   $__referrer=Referrer::_print_($__url);
   echo"<p><a href='".$__referrer."' target='_top' title='".$__referrer."' class='data1'>"._cut_($__referrer,60)."</a></p>";
   unset($__referrer);
  }

  echo"</td>";
  echo"<td class='graphic'>";
  echo _bar_($__hits,$__perc["~max~"],200);
  echo"</td>";
  echo"<td class='data3'>";
  echo"<p>".$__perc[$__url]."</p>";
  echo"</td>";
  echo"</tr>";
 }

 unset($__perc,$__url,$__hits);
}
else{
 echo"<tr>";
 echo"<td colspan='3' class='data1'>";
 echo"<p>".$lan__strings["emptydata"]."</p>";
 echo"</td>";
 echo"</tr>";
}

echo"</table>";
echo"</td>";
echo"</tr>";

unset($dat__referrer);

echo"<tr>";
echo"<td>";
echo"<p><a href='javascript:self.scroll(0,0)' class='top'>"._format_($lan__strings["top"])."</a></p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<p class='title'>"._format_($lan__strings["section04"])."</p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td style='padding:0px;'>";
echo"<table cellspacing='0' style='width:100%;height:auto;'>";
echo"<tr>";
echo"<td>";
echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field20"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:120px'>";
echo"<p>"._format_($lan__strings["field21"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field22"])."</p>";
echo"</th>";
echo"</tr>";

if(count($dat__engine)>0){
 $dat__engine=_restrict_($dat__engine);
 $__perc=_percentage_($dat__engine);

 foreach($dat__engine as $__engine=>$__hits){
  echo"<tr>";
  echo"<td class='data1' style='text-align:left;'>";

  if($__engine===$lan__strings["other"])
   echo"<p style='font-style:italic;'>".$__engine."</p>";
  else
   echo"<p><a href='http://www.".$__engine."' target='_top' title='http://www.".$__engine."' class='data1'>"._cut_($__engine,24)."</a></p>";

  echo"</td>";
  echo"<td class='graphic'>";
  echo _bar_($__hits,$__perc["~max~"],120);
  echo"</td>";
  echo"<td class='data3'>";
  echo"<p>".$__perc[$__engine]."</p>";
  echo"</td>";
  echo"</tr>";
 }

 unset($__perc,$__engine,$__hits);
}
else{
 echo"<tr>";
 echo"<td colspan='3' class='data1'>";
 echo"<p>".$lan__strings["emptydata"]."</p>";
 echo"</td>";
 echo"</tr>";
}

echo"</table>";
echo"</td>";
echo"<td>";
echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field23"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:120px'>";
echo"<p>"._format_($lan__strings["field24"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field25"])."</p>";
echo"</th>";
echo"</tr>";

if(count($dat__enkey)>0){
 $dat__enkey=_restrict_($dat__enkey);
 $__perc=_percentage_($dat__enkey);

 foreach($dat__enkey as $__enkey=>$__hits){
  echo"<tr>";
  echo"<td class='data1' style='text-align:right;'>";

  if($__enkey===$lan__strings["other"])
   echo"<p style='font-style:italic;'>".$__enkey."</p>";
  else
   echo"<p>"._cut_($__enkey,24)."</p>";

  echo"</td>";
  echo"<td class='graphic'>";
  echo _bar_($__hits,$__perc["~max~"],120);
  echo"</td>";
  echo"<td class='data3'>";
  echo"<p>".$__perc[$__enkey]."</p>";
  echo"</td>";
  echo"</tr>";
 }

 unset($__perc,$__enkey,$__hits);
}
else{
 echo"<tr>";
 echo"<td colspan='3' class='data1'>";
 echo"<p>".$lan__strings["emptydata"]."</p>";
 echo"</td>";
 echo"</tr>";
}

echo"</table>";
echo"</td>";
echo"</tr>";
echo"</table>";
echo"</td>";
echo"</tr>";

unset($dat__engine,$dat__enkey);

echo"<tr>";
echo"<td>";
echo"<p><a href='javascript:self.scroll(0,0)' class='top'>"._format_($lan__strings["top"])."</a></p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<p class='title'>"._format_($lan__strings["section05"])."</p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td style='padding:0px;'>";
echo"<table cellspacing='0' style='width:100%;height:auto;'>";
echo"<tr>";
echo"<td>";
echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field26"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:120px'>";
echo"<p>"._format_($lan__strings["field27"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field28"])."</p>";
echo"</th>";
echo"</tr>";

$dat__browser=_restrict_($dat__browser);
$__perc=_percentage_($dat__browser);

foreach($dat__browser as $__browser=>$__hits){
 echo"<tr>";
 echo"<td class='data1' style='text-align:right;'>";

 if($__browser==="?")
  echo"<p style='font-style:italic;'>".$lan__strings["unknownbrowser"]."</p>";
 elseif($__browser===$lan__strings["other"])
  echo"<p style='font-style:italic;'>".$__browser."</p>";
 else
  echo"<p>"._cut_($__browser,24)."</p>";

 echo"</td>";
 echo"<td class='graphic'>";
 echo _bar_($__hits,$__perc["~max~"],120);
 echo"</td>";
 echo"<td class='data3'>";
 echo"<p>".$__perc[$__browser]."</p>";
 echo"</td>";
 echo"</tr>";
}

unset($__perc,$__browser,$__hits);

echo"</table>";
echo"</td>";
echo"<td>";
echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field29"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:120px'>";
echo"<p>"._format_($lan__strings["field30"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field31"])."</p>";
echo"</th>";
echo"</tr>";

$dat__os=_restrict_($dat__os);
$__perc=_percentage_($dat__os);

foreach($dat__os as $__os=>$__hits){
 echo"<tr>";
 echo"<td class='data1' style='text-align:right;'>";

 if($__os==="?")
  echo"<p style='font-style:italic;'>".$lan__strings["unknownos"]."</p>";
 elseif($__os===$lan__strings["other"])
  echo"<p style='font-style:italic;'>".$__os."</p>";
 else
  echo"<p>"._cut_($__os,24)."</p>";

 echo"</td>";
 echo"<td class='graphic'>";
 echo _bar_($__hits,$__perc["~max~"],120);
 echo"</td>";
 echo"<td class='data3'>";
 echo"<p>".$__perc[$__os]."</p>";
 echo"</td>";
 echo"</tr>";
}

unset($__perc,$__os,$__hits);

echo"</table>";
echo"</td>";
echo"</tr>";
echo"</table>";
echo"</td>";
echo"</tr>";

unset($dat__browser,$dat__os);

echo"<tr>";
echo"<td>";
echo"<p><a href='javascript:self.scroll(0,0)' class='top'>"._format_($lan__strings["top"])."</a></p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<p class='title'>"._format_($lan__strings["section06"])."</p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field32"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:335px'>";
echo"<p>"._format_($lan__strings["field33"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field34"])."</p>";
echo"</th>";
echo"</tr>";

$dat__country=_restrict_($dat__country);
$__perc=_percentage_($dat__country);

foreach($dat__country as $__country=>$__hits){
 echo"<tr>";
 echo"<td class='data1' style='text-align:right;'>";

 if($__country==="?")
  echo"<p style='font-style:italic;'>".$lan__strings["unknowncountry"]."</p>";
 elseif($__country===$lan__strings["other"])
  echo"<p style='font-style:italic;'>".$__country."</p>";
 else
  echo"<p>"._cut_($__country,45)."</p>";

 echo"</td>";
 echo"<td class='graphic'>";
 echo _bar_($__hits,$__perc["~max~"],335);
 echo"</td>";
 echo"<td class='data3'>";
 echo"<p>".$__perc[$__country]."</p>";
 echo"</td>";
 echo"</tr>";
}

unset($__perc,$__country,$__hits);

echo"</table>";
echo"</td>";
echo"</tr>";

unset($dat__country);

echo"<tr>";
echo"<td>";
echo"<p><a href='javascript:self.scroll(0,0)' class='top'>"._format_($lan__strings["top"])."</a></p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td>";
echo"<p class='title'>"._format_($lan__strings["section07"])."</p>";
echo"</td>";
echo"</tr>";
echo"<tr>";
echo"<td style='padding:0px;'>";
echo"<table cellspacing='0' style='width:100%;height:auto;'>";
echo"<tr>";
echo"<td>";

if($cnf__last_dates>0){
 echo"<table class='section' style='margin-bottom:20px;'>";
 echo"<tr>";
 echo"<th class='field1'>";
 echo"<p>"._format_($lan__strings["field42"])."</p>";
 echo"</th>";
 echo"<th class='field1' style='width:140px'>";
 echo"<p>"._format_($lan__strings["field43"])."</p>";
 echo"</th>";
 echo"<th class='field1' style='width:50px'>";
 echo"<p>"._format_($lan__strings["field44"])."</p>";
 echo"</th>";
 echo"<th class='field1' style='width:50px'>";
 echo"<p>"._format_($lan__strings["field45"])."</p>";
 echo"</th>";
 echo"</tr>";

 for($__count=$cnf__last_dates-1,$__dates=array();$__count>=0;$__count--)
  $__dates[_timestamp_($__count,"d")]=$aux__calendar->_get_hits_(_timestamp_($__count,"d"),"d");
 unset($__count);

 $__perc=_percentage_($__dates);

 foreach($__dates as $__date=>$__hits){
  echo"<tr>";
  echo"<td class='data1' style='text-align:right;'>";
  echo"<p title='"._date_($__date,"w")."' style='".((date("w",$__date)==="0")?"font-weight:bold;":"")."cursor:help;'>"._date_($__date,"d")."</p>";
  echo"</td>";
  echo"<td class='graphic'>";
  echo _bar_($__hits,$__perc["~max~"],140);
  echo"</td>";
  echo"<td class='data3'>";
  echo"<p>".$__perc[$__date]."</p>";
  echo"</td>";
  echo"<td class='data2'>";
  echo"<p>".($aux__max_d["hits"]-$__hits)."</p>";
  echo"</td>";
  echo"</tr>";
 }

 unset($__dates,$__perc,$__date,$__hits);

 echo"</table>";
}

echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field46"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:196px'>";
echo"<p>"._format_($lan__strings["field47"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field48"])."</p>";
echo"</th>";
echo"</tr>";

$__perc=_percentage_($dat__day);

foreach($dat__day as $__day=>$__hits){
 echo"<tr>";
 echo"<td class='data1' style='text-align:right;'>";
 echo"<p".(($__day===6)?" style='font-weight:bold;'":"").">".$lan__days[$__day]."</p>";
 echo"</td>";
 echo"<td class='graphic'>";
 echo _bar_($__hits,$__perc["~max~"],196);
 echo"</td>";
 echo"<td class='data3'>";
 echo"<p>".$__perc[$__day]."</p>";
 echo"</td>";
 echo"</tr>";
}

unset($__perc,$__day,$__hits);

echo"</table>";
echo"</td>";
echo"<td>";
echo"<table class='section' style='margin-bottom:20px;'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field35"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:176px'>";
echo"<p>"._format_($lan__strings["field36"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field37"])."</p>";
echo"</th>";
echo"</tr>";

$__years=$aux__calendar->_get_years_();
$__perc=_percentage_($__years);

foreach($__years as $__year=>$__hits){
 echo"<tr>";
 echo"<td class='data1' style='text-align:right;'>";
 echo"<p>".$__year."</p>";
 echo"</td>";
 echo"<td class='graphic'>";
 echo _bar_($__hits,$__perc["~max~"],176);
 echo"</td>";
 echo"<td class='data3'>";
 echo"<p>".$__perc[$__year]."</p>";
 echo"</td>";
 echo"</tr>";
}

unset($__years,$__perc,$__year,$__hits);

echo"</table>";

if($cnf__last_months>0){
 echo"<table class='section' style='margin-bottom:20px;'>";
 echo"<tr>";
 echo"<th class='field1'>";
 echo"<p>"._format_($lan__strings["field38"])."</p>";
 echo"</th>";
 echo"<th class='field1' style='width:120px'>";
 echo"<p>"._format_($lan__strings["field39"])."</p>";
 echo"</th>";
 echo"<th class='field1' style='width:50px'>";
 echo"<p>"._format_($lan__strings["field40"])."</p>";
 echo"</th>";
 echo"<th class='field1' style='width:50px'>";
 echo"<p>"._format_($lan__strings["field41"])."</p>";
 echo"</th>";
 echo"</tr>";

 for($__count=$cnf__last_months-1,$__months=array();$__count>=0;$__count--)
  $__months[_timestamp_($__count,"m")]=$aux__calendar->_get_hits_(_timestamp_($__count,"m"),"m");
 unset($__count);

 $__perc=_percentage_($__months);

 foreach($__months as $__month=>$__hits){
  echo"<tr>";
  echo"<td class='data1' style='text-align:right;'>";
  echo"<p>"._date_($__month,"m")."</p>";
  echo"</td>";
  echo"<td class='graphic'>";
  echo _bar_($__hits,$__perc["~max~"],120);
  echo"</td>";
  echo"<td class='data3'>";
  echo"<p>".$__perc[$__month]."</p>";
  echo"</td>";
  echo"<td class='data2'>";
  echo"<p>".($aux__max_m["hits"]-$__hits)."</p>";
  echo"</td>";
  echo"</tr>";
 }

 unset($__months,$__perc,$__month,$__hits);

 echo"</table>";
}

echo"<table class='section'>";
echo"<tr>";
echo"<th class='field1'>";
echo"<p>"._format_($lan__strings["field49"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:176px'>";
echo"<p>"._format_($lan__strings["field50"])."</p>";
echo"</th>";
echo"<th class='field1' style='width:50px'>";
echo"<p>"._format_($lan__strings["field51"])."</p>";
echo"</th>";
echo"</tr>";

$__perc=_percentage_($dat__time);

foreach($dat__time as $__time=>$__hits){
 echo"<tr>";
 echo"<td class='data1' style='text-align:right;'>";
 echo"<p>"._time_($__time)."</p>";
 echo"</td>";
 echo"<td class='graphic'>";
 echo _bar_($__hits,$__perc["~max~"],176);
 echo"</td>";
 echo"<td class='data3'>";
 echo"<p>".$__perc[$__time]."</p>";
 echo"</td>";
 echo"</tr>";
}

unset($__perc,$__time,$__hits);

echo"</table>";
echo"</td>";
echo"</tr>";
echo"</table>";
echo"</td>";
echo"</tr>";

unset($dat__time,$dat__day);

echo"<tr>";
echo"<td>";
echo"<p><a href='javascript:self.scroll(0,0)' class='top'>"._format_($lan__strings["top"])."</a></p>";
echo"</td>";
echo"</tr>";

list($__usec_e,$__sec_e)=explode(" ",microtime());

echo"<tr>";
echo"<td>";
echo"<p class='credits'>"._format_($lan__strings["epilogue"],round((float)$__sec_e-(float)$aux__sec_s+(float)$__usec_e-(float)$aux__usec_s,2))."</p>";
echo"</td>";
echo"</tr>";

unset($__usec_e,$__sec_e);

echo"</table>";
echo"</div>";
echo"</body>";
echo"</html>";
echo"\n\n";

############################################################################################
# EPILOGO ESECUZIONE
############################################################################################

unset($glo__licit_domains_list,$glo__config_f,$glo__counter_f,$glo__reports_f,$glo__archive_f,$glo__access_f,$glo__log_f,$glo__tmp_f,$glo__bck_f,$glo__field_sep,$glo__EOL,$glo__lock_files,$glo__auto_backup,$glo__get_host_name,$glo__script_vs,$glo__script_hp,$glo__script_email);
unset($cnf__start_count,$cnf__img_base,$cnf__pad_char,$cnf__text_size,$cnf__text_color,$cnf__box_draw,$cnf__box_color,$cnf__box_align,$cnf__licit_domains_list,$cnf__IPs_ignore_list,$cnf__mtime_unique_accs,$cnf__expire_on_midnight,$cnf__count_per_pages,$cnf__access_support,$cnf__htime_sync_server,$cnf__style_sheet,$cnf__last_entries,$cnf__last_months,$cnf__last_dates,$cnf__limit_view,$cnf__ksize_limit_db);
unset($par__id);
unset($lan__months,$lan__days,$lan__strings);
unset($aux__calendar,$aux__usec_s,$aux__sec_s,$aux__now,$aux__max_d,$aux__max_m);

############################################################################################

?>