<?php

############################################################################################
# fanKounter PHP script                                                          url.inc.php
# fanatiko(lubcecco@hotmail.com),Italy                                                  v4.0

############################################################################################
# INFORMAZIONI SUL FILE
############################################################################################
# Modulo auto-incluso per la gestione di URLs, referrers e motori di ricerca.
#
# Fai riferimento alla seguente documentazione distribuita con questo software per:
#  license.txt - le condizioni di utilizzo, modifica e redistribuzione per l'utente finale;
#   readme.txt - la guida completa all'installazione e all'uso, con consigli preziosi;
# whatsnew.txt - i bugs trovati e corretti e le novit rispetto alle versioni precedenti.

############################################################################################
# INCLUSIONE MODULI ESTERNI
############################################################################################

require("inf-engine.inc.php");
require("dic.inc.php");

############################################################################################
# DEFINIZIONE DELLA CLASSE URL
############################################################################################

class URL{
 var $__url_v;

 function URL($__url,$__encoded=FALSE){
  $__url_v=array("prot"=>"","host"=>"","port"=>"","path"=>"","page"=>"","para"=>"");

  do
   $__url=urldecode($__url);
  while(preg_match("/%[a-f\d]{2}/i",$__url));

  if(!$__encoded){
   $__url=(get_magic_quotes_gpc())?stripslashes($__url):$__url;
   $__url=ereg_replace("[\x5C]","\\"."\\",$__url);
   $__url=preg_replace("/[\x01-\x1F]/","",$__url);
   $__url=preg_replace("/(\S)\s{2,}(\S)/","\\1 \\2",$__url);
   $__url=trim($__url);
  }

  if(preg_match("/^(http:\/\/)/i",$__url,$__result)){
   $__url=trim(preg_replace("/^".preg_quote($__result[1],"/")."/","",$__url));
   $__url_v["prot"]=strtolower($__result[1]);
  }
  else{
   $this->__url_v=FALSE;
   return;
  }

  if(preg_match("/^(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})(:|\/|$)/",$__url,$__result)){
   $__url=preg_replace("/^".preg_quote($__result[1],"/")."/","",$__url);
   $__url_v["host"]=$__result[1];
  }
  elseif(preg_match("/^(([a-z\d]\.|[a-z\d][a-z\d\-]*[a-z\d]\.)*)(([a-z]|[a-z][a-z\d\-]*[a-z\d])\.[a-z]{2,4})(:|\/|$)/i",$__url,$__result)){
   $__url=preg_replace("/^".preg_quote($__result[1].$__result[3],"/")."/","",$__url);
   $__url_v["host"]=strtolower((($__result[1]!=="")?$__result[1]:"www.").$__result[3]);
  }
  else{
   $this->__url_v=FALSE;
   return;
  }

  if(preg_match("/^(:\d*|)(\/|$)/",$__url,$__result)){
   $__url=preg_replace("/^".preg_quote($__result[1],"/")."/","",$__url);
   $__url_v["port"]=(($__result[1]===":")||($__result[1]===":80"))?"":$__result[1];
  }
  else{
   $this->__url_v=FALSE;
   return;
  }

  if(preg_match("/^[^?]*(\?.*)$/",$__url,$__result)){
   $__url=trim(preg_replace("/".preg_quote($__result[1],"/")."$/","",$__url));
   $__url_v["para"]=$__result[1];
  }

  if(preg_match("/^.*(\/[^\/]+\.[^\/\s.]+)$/",$__url,$__result)){
   $__url=trim(preg_replace("/".preg_quote($__result[1],"/")."$/","",$__url));
   $__url_v["page"]="/".trim(substr($__result[1],1));
  }

  if(preg_match_all("/(\/[^\/]*)/",$__url,$__result)){
   $__url=preg_replace("/".preg_quote(implode("",$__result[1]),"/")."/","",$__url);

   foreach($__result[1] as $__index=>$__path)
    $__result[1][$__index]="/".trim(substr($__path,1),"\x5C\x20");

   for($__count=0;$__count<count($__result[1]);$__count++)
    switch($__result[1][$__count]){
     case "/..":
      if($__count>0)
       unset($__result[1][$__count-1]);
     case "/":
     case "/.":
      unset($__result[1][$__count]);
      $__result[1]=array_values($__result[1]);
      $__count=-1;
    }

   $__url_v["path"]=implode("",$__result[1]);
  }

  $this->__url_v=($__url==="")?$__url_v:FALSE;
  return;
 }

 function _safe_(){
  return (($this->__url_v!==FALSE)?urlencode(implode("",$this->__url_v)):FALSE);
 }

 function _normalize_(){
  $__page=(preg_match("/^\/index\./i",$this->__url_v["page"]))?"":$this->__url_v["page"];

  if($this->__url_v!==FALSE)
   return urlencode($this->__url_v["prot"].$this->__url_v["host"].$this->__url_v["port"].$this->__url_v["path"].$__page);
  else
   return "?";
 }

 function _print_($__encoded_url=""){
  if($__encoded_url==="")
   $__encoded_url=$this->_normalize_();

  return ereg_replace("[\x5C]{2}","&#92;",htmlspecialchars(urldecode($__encoded_url),ENT_QUOTES));
 }
}

############################################################################################
# DEFINIZIONE DELLA SOTTO-CLASSE REFERRER
############################################################################################

class Referrer extends URL{
 var $__engine_name;
 var $__engine_keys_v;

 function Referrer($__url,$__encoded=FALSE){
  global $inf__engine;
  global $dic__keys_minlen,$dic__keys_exclude;

  parent::URL($__url,$__encoded);

  if($this->__url_v!==FALSE)
   foreach($inf__engine as $__name=>$__param)
    if(preg_match("/\.(".preg_quote($__name,"/")."\..+)$/i",$this->__url_v["host"],$__result)){
     $this->__engine_name=strtolower($__result[1]);

     if(preg_match("/[?&]".$__param."=([^&]+)(&|$)/i",$this->__url_v["para"],$__result)){
      $__result[2]=preg_replace("/[^\w\d\s]/"," ",$__result[2]);
      $__result[2]=trim(preg_replace("/(\S)\s{2,}(\S)/","\\1 \\2",$__result[2]));
      $this->__engine_keys_v=explode(" ",strtolower($__result[2]));

      foreach($this->__engine_keys_v as $__index=>$__enkey)
       if(strlen($__enkey)<$dic__keys_minlen)
        unset($this->__engine_keys_v[$__index]);

      $this->__engine_keys_v=array_diff($this->__engine_keys_v,$dic__keys_exclude);

      sort($this->__engine_keys_v,SORT_STRING);

      if(count($this->__engine_keys_v)>0)
       return;
     }
    }

  $this->__engine_name=FALSE;
  $this->__engine_keys_v=FALSE;
  return;
 }

 function _is_engine_(){
  return ((($this->__engine_name===FALSE)||($this->__engine_keys_v===FALSE))?FALSE:TRUE);
 }

 function _get_engine_name_(){
  return (($this->_is_engine_())?$this->__engine_name:"?");
 }

 function _get_engine_keys_(){
  return (($this->_is_engine_())?$this->__engine_keys_v:"?");
 }
}

############################################################################################

?>